=== ports/lilypad/Makefile ===
#
# Copyright © 2020 Keith Packard <keithp@keithp.com>
#
# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation, either version 3 of the License, or
# (at your option) any later version.
#
# This program is distributed in the hope that it will be useful, but
# WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
# General Public License for more details.
#

SNEK_NO_DICT=1
BOARD=lilypad
CBOARD=LilyPad
UBOARD=LILYPAD
PORT=/dev/ttyUSB0
BAUD=57600
CLOCK=8000000
MCU=m328p

SNEK_ATMEGA_BUILTINS_EXTRA = \
	snek-tone.builtin

include ../duemilanove/Makefile
