=== debian/changelog ===
snek (1.10-1) unstable; urgency=medium

  * New upstream version

  * Adapt to new gcc-avr version. Closes: #1088139.

  * Depend on arch-specific qemu packages. Close: #1086204.

 -- Keith Packard <keithp@keithp.com>  Thu, 28 Nov 2024 12:30:53 -0800

snek (1.9-3) unstable; urgency=medium

  * Fix lintian errors

 -- Keith Packard <keithp@keithp.com>  Wed, 27 Sep 2023 11:27:47 -0700

snek (1.9-2) unstable; urgency=medium

  * Fix ev3 build to avoid inheriting host CFLAGS. Closes: #1052744.

 -- Keith Packard <keithp@keithp.com>  Tue, 26 Sep 2023 22:03:17 -0700
