=== debian/control ===
--- 
+++ 
@@ -7,9 +7,9 @@
 Build-Depends-Indep: avr-libc, gcc-avr,
  binutils-arm-none-eabi, gcc-arm-none-eabi, picolibc-arm-none-eabi (>= 1.4), qemu-system-arm,
  binutils-riscv64-unknown-elf, gcc-riscv64-unknown-elf, picolibc-riscv64-unknown-elf (>= 1.4),
- gcc-arm-linux-gnueabi, libc6-dev-armel-cross, qemu-system-misc,
+ gcc-arm-linux-gnueabi, libc6-dev-armel-cross, qemu-system-riscv,
  asciidoctor, ruby-asciidoctor-pdf, ruby-coderay
-Standards-Version: 4.6.2
+Standards-Version: 4.7.0
 Homepage: https://sneklang.org
 Vcs-Git: git://sneklang.org/git/snek.git
 Vcs-Browser: https://sneklang.org/cgit/snek.git
