## snek 1.11

=== Makefile ===
--- 
+++ 
@@ -35,10 +35,10 @@
 	+cd test && make $@
 
 black:
-	+black --check --exclude 'fail-syntax-.*\.py|.*/hosts/.*.py' .
+	+black --check --exclude 'fail-syntax-.*\.py|.*/hosts/.*.py|ubaboot.py' .
 
 black-reformat:
-	+black --exclude 'fail-syntax-.*\.py|.*/hosts/.*.py' .
+	+black --exclude 'fail-syntax-.*\.py|.*/hosts/.*.py|ubaboot.py' .
 
 install: all
 	+for dir in $(SUBDIRS); do (cd $$dir && make PREFIX=$(PREFIX) DESTDIR=$(DESTDIR) $@) || exit 1; done
@@ -46,13 +46,13 @@
 
 upload: otheros
 	+cd doc && make upload
-	+for otheros in $(SNEK_OTHEROS_DIR); do (cd "$$otheros" && make upload); done
+	+for otheros in $(SNEK_OTHEROS_DIR); do (cd "$$otheros" && make upload) || exit 1; done
 
 install-otheros: otheros install
-	+for otheros in $(SNEK_OTHEROS_DIR); do (cd "$$otheros" && make install-otheros); done
+	+for otheros in $(SNEK_OTHEROS_DIR); do (cd "$$otheros" && make install-otheros) || exit 1; done
 
 otheros: all
-	+for otheros in $(SNEK_OTHEROS_DIR); do (cd "$$otheros" && make); done
+	+for otheros in $(SNEK_OTHEROS_DIR); do (cd "$$otheros" && make) || exit 1; done
 
 snek-mu.py:
 	find . -name '*.builtin' -print0 | xargs -0 python3 ./snek-builtin.py --mu -o $@
