=== ports/itsybitsy3v/Makefile ===
#
# Copyright © 2019 Keith Packard <keithp@keithp.com>
#
# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation, either version 3 of the License, or
# (at your option) any later version.
#
# This program is distributed in the hope that it will be useful, but
# WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
# General Public License for more details.
#

AVR_CLOCK=8000000UL
PROGNAME=snek-itsybitsy3v
PRODUCT_NAME=SnekItsyBitsy3v
BUILD_INSTALL=0

SNEK_PORT=../itsybitsy5v

include ../itsybitsy5v/Makefile
